﻿Option Strict Off
Imports System
Imports Wisej.Web
Imports System.Threading
Imports System.Threading.Tasks
Imports Wisej.Core

Module Program
    Private strEmail As String = "hold"
    ''' <summary>
    ''' The main entry point for the application.
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub Main()

        Application.Session.UserEmail = "fail"

        'get user email from token header put in Application.Session.UserEmail

        'ProcessDataAsync1() '- hangs up when executing javascript
        'ProcessDataAsync2()
        ProcessDataAsync3()

        Application.MainPage = New Page1()


    End Sub

    Private Async Sub ProcessDataAsync1()

        Dim task As Task(Of Boolean) = RunJavaScriptCodeAsync()
        Dim success = Await task.ConfigureAwait(False)
        task.Wait()



        If strEmail <> "hold" Then Application.Session.UserEmail = strEmail

    End Sub


    Private Async Sub ProcessDataAsync2()

        Dim task As Task(Of Boolean) = RunJavaScriptCodeAsync()

        task.Wait(2000)


        Dim success = Await task.ConfigureAwait(False)
        If strEmail <> "hold" Then Application.Session.UserEmail = strEmail

    End Sub


    Private Async Sub ProcessDataAsync3()

        Dim success = Await RunJavaScriptCodeAsync()
        If strEmail <> "hold" Then Application.Session.UserEmail = strEmail

    End Sub

    Private Async Function RunJavaScriptCodeAsync() As Task(Of Boolean) ' javascript works if not run in async, but hangs as shown
        Try
            Await Application.EvalAsync("

            var req = new qx.io.remote.Request('https://designportalalex.azurewebsites.net/.auth/me', 'GET', 'text/plain');

            req.setCrossDomain(true);
            req.setProhibitCaching(false);

            req.addListener('completed', function(e) {
               alert(e.getContent());
               var response = e.getContent();
               App.GetToken(response);
            });
            // Send request
            req.send()")

        Catch ex As Exception
            Alertbox.Show($"Error during interact authentication: {ex.Message}")
            Return False
        End Try

        Return True

    End Function

    <WebMethod>
    Public Sub GetToken(T As String) 'method confirmed with test data
        Dim SearchWithinThis As String = T

        Dim SearchForThis As String = "emails"
        Dim FirstCharacter As Integer = SearchWithinThis.IndexOf(SearchForThis) + 16

        SearchForThis = "B2C_1_signup_signin"
        Dim LastCharacter As Integer = SearchWithinThis.IndexOf(SearchForThis) - 23

        Dim Length As Int16 = ((Len(T) - FirstCharacter) - (Len(T) - LastCharacter)) + 1

        strEmail = Strings.Mid(T, FirstCharacter, Length)

    End Sub
    ' ''' <summary>
    ' ''' You can use the entry method below
    ' ''' to receive the parameters from the URL in the args collection.
    ' ''' </summary>
    ' ''' <param name="args"></param>
    ' ''' <remarks></remarks>
    'Public Sub Main(args As NameValueCollection)

    'End Sub

End Module